
#include "CTaskTurnGame.h"
#include "Hooks.h"
#include "TeamBar.h"

int (__fastcall *origHandleTaskMessage)(CTaskTurnGame * This, int EDX, void * sender, int mtype, size_t size, void * data);
int __fastcall CTaskTurnGame::hookHandleTaskMessage(CTaskTurnGame * This, int EDX, void * sender, int mtype, size_t size, void * data) {
	if(mtype == TaskMessage_UpdateNonCritical) {
		TeamBar::onUpdateNonCritical();
	}
	return origHandleTaskMessage(This, 0, sender, mtype, size, data);
}

void CTaskTurnGame::install() {
	auto & hooks = Hooks::getInstance();

	DWORD addrCTaskTurnGameConstructor = hooks.findSignature("CTaskTurnGameConstructor", "\x6A\xFF\x68\x00\x00\x00\x00\x64\xA1\x00\x00\x00\x00\x50\x64\x89\x25\x00\x00\x00\x00\x53\x55\x8B\x6C\x24\x1C\x56\x8B\x74\x24\x1C\x57\x55\x8B\xF9\x57\x56\xE8\x00\x00\x00\x00\x33\xDB\x89\x5C\x24\x18\xC7\x06\x00\x00\x00\x00\xC7\x46\x00\x00\x00\x00\x00\xC7\x46\x00\x00\x00\x00\x00", "???????xx????xxxx????xxxxxxxxxxxxxxxxxx????xxxxxxxx????xx?????xx?????"); //55AD80
	DWORD* addrCTaskTurnGameVTable = *(DWORD**)(addrCTaskTurnGameConstructor + 0x33);
	DWORD addrCTaskTurnGame_HandleTaskMessage = addrCTaskTurnGameVTable[2];
	hooks.hook("CTaskTurnGame_HandleTaskMessage", addrCTaskTurnGame_HandleTaskMessage, (DWORD*)&hookHandleTaskMessage, (DWORD*)&origHandleTaskMessage);
}
