#ifndef WKFLAMINGHEALTHBARS_HOOKS_H
#define WKFLAMINGHEALTHBARS_HOOKS_H

#include <sigscanner.h>

class Hooks {
private:
	Hooks();
	~Hooks() = default;

	SignatureScanner SigScanner;
	module mod;
public:
	Hooks(Hooks &) = delete;
	void operator=(const Hooks &) = delete;

	static Hooks & getInstance();

	void hook(std::string name, DWORD pTarget, DWORD *pDetour, DWORD *ppOriginal);
	DWORD findSignature(std::string name, const char* sig, const char* mask);
};


#endif //WKFLAMINGHEALTHBARS_HOOKS_H
